// $Id: hello.m,v 1.4.2.2 2013/06/05 12:42:09 rjs Exp $
//
//  hello.m
//  PDFlib
//
//

#import "hello.h"

#if TARGET_OS_IPHONE
#import "PDFlib_ios/PDFlib_objc.h"
#else
#import "PDFlib/PDFlib_objc.h"
#endif

@implementation hello

+ (NSData *) run {
    NSData *pdfdata=nil;
    NSInteger font;
        
    /* create a new PDFlib object */
    PDFlib *pdflib = [[PDFlib alloc] init];
    if (!pdflib) {
         return nil;
    }
    
    @try { 
        [pdflib set_option:@"errorpolicy=exception"];

        [pdflib begin_document:@"" optlist:@""];
        
        [pdflib set_info:@"Creator" value:@"hello_ios"];
        [pdflib set_info:@"Author" value:@"Thomas Merz"];
        [pdflib set_info:@"Title" value:@"Hello, world (Objective-C)"];
        
        [pdflib begin_page_ext:a4_width height:a4_height optlist:@""];
        
        font = [pdflib load_font:@"Helvetica-Bold"
                        encoding:@"unicode" optlist:@""];
       
        [pdflib setfont:font fontsize:24];
        [pdflib set_text_pos: 50 y:700];
        
        [pdflib show:@"Hello, world!"];
        [pdflib continue_text:@"(says Objective-C)"];
        [pdflib end_page_ext:@""];
        [pdflib end_document:@""];
        
        pdfdata = [pdflib get_buffer];
    } 
    @catch (PDFlibException *ex) { 
        NSString * errorMessage = 
	    [NSString stringWithFormat:@"PDFlib error %ld in '%@': %@",
            (long)[ex get_errnum], [ex get_apiname], [ex get_errmsg]];
#if TARGET_OS_IPHONE
        UIAlertView *alert = [[UIAlertView alloc] 
            initWithTitle:[ex name] message:errorMessage
            delegate:self cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alert show];
#else
        NSAlert *alert = [[NSAlert alloc] init];
        [alert setMessageText: errorMessage];
        [alert runModal];
#endif
    }
    @catch (NSException *ex) { 
#if TARGET_OS_IPHONE
        UIAlertView *alert = [[UIAlertView alloc] 
            initWithTitle:[ex name] message:[ex reason]
            delegate:self cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alert show];
#else
        NSAlert *alert = [[NSAlert alloc] init];
        [alert setMessageText: [ex reason]];
        [alert runModal];
#endif
    } 

    return pdfdata;
}

@end
